<?php
/*
Plugin Name: spam-stopper
Plugin URI: http://wordpress.org/extend/plugins/spam-stopper/
Description: Protect your blog from comments spam with a simple validation question. To config the spam question or disable adding the form field automatically, edit the plugin file.
Version: 3.0.4
Author: Mike Jolley
Author URI: http://blue-anvil.com
*/
if (!class_exists('WPcommentSpam')) {

		class WPcommentSpam {

				var $spam_question;
				var $spam_answer;

				//constructor
				function WPcommentSpam() {
				
						##==================================================================================================##
						##										                                                            ##
						##	Config the following varibles	                                                                ##
						##										                                                            ##
						##--------------------------------------------------------------------------------------------------##
						
						// The following question will be asked when the user fills in the comment form
									
						$this->spam_question = "Is Fire hot or cold?";
									
						// This is the answer to the above question, it is not case sensitive
									
						$this->spam_answer = "Hot";
									
						// Set this option to 0 if you wish to manually add the spam question form field to the 
						// comment form.
						//
						// To manually add the form element to the comments template, open the comments template and insert
						// the following into the comments form:
						//
						//		<!-- Required anti spam confirmation -->
						//		<p id="aspamquestion">
						//		<label for="spamq"><small>< ?php $aspamq = new WPcommentSpam(); echo $aspamq->get_spam_question(); ? > (required)</small></label>
						//		<input type="text" name="spamq" id="spamq" value="" size="15" maxlength="30" tabindex="3" /> <small class="whythis" title="This confirms you are a human user!">- <a href="#spamq" style="cursor:help;">Why ask? <span>This confirms you are a human user!</span></a></small>
						//		</p>
						// If you modify this field, ensure id's and name's are not changed from those present currently.
									
						$showField = 1;	
						
						##===========================================================================================End Config
						
						if ( $showField) {
								add_action('comment_form', array(&$this, 'comment_form'));
						}
						add_filter('preprocess_comment', array(&$this, 'check_comment'),0);						
				}			
				function get_spam_question() {
						return $this->spam_question;
				}
				function comment_form() {
				
						global $user_ID;
						if (isset($user_ID)) {						
									//logged in so no need for form
									return $post_ID;
						} else {
									if (strstr(get_bloginfo('template_directory'), "default")) {
									?>
										<!-- Required anti spam confirmation -->
										<p id="aspamquestion">										
										<input type="text" name="spamq" id="spamq" value="" size="15" maxlength="30" tabindex="3" /> <label for="spamq"><small><?php echo $this->spam_question; ?> (required) - <span class="whyask" title="This confirms you are a human user!" style="cursor:help;">Why ask?</span></small></label>
										</p>
									<?php									
									} else {
									?>
										<!-- Required anti spam confirmation -->
										<p id="aspamquestion">
										<label for="spamq"><small><?php echo $this->spam_question; ?> (required)</small></label>
										<input type="text" name="spamq" id="spamq" size="15" maxlength="30" tabindex="3" /> <small><span class="whyask" title="This confirms you are a human user!" style="cursor:help;">Why ask?</span></small>
										</p>
									<?php
									}
									?>									
									<script type="text/javascript">
										<!--
											jQuery(function(){
											
												function getCookieVal (offset) {
												  var endstr = document.cookie.indexOf (";", offset);
												  if (endstr == -1) { endstr = document.cookie.length; }
												  return unescape(document.cookie.substring(offset, endstr));
												}
												function GetCookie (name) {
												  var arg = name + "=";
												  var alen = arg.length;
												  var clen = document.cookie.length;
												  var i = 0;
												  while (i < clen) {
													var j = i + alen;
													if (document.cookie.substring(i, j) == arg) {
													  return getCookieVal (j);
													  }
													i = document.cookie.indexOf(" ", i) + 1;
													if (i == 0) break; 
													}
												  return null;
												}
												jQuery('#email').parent().after(jQuery('#aspamquestion'));
												// Set comment if cookie exists
												if (GetCookie('cached_error_comment') == null) {} else {
													jQuery('#comment').val(unescape(GetCookie('cached_error_comment')));
												}
											});						
										//-->
									</script>
									<?php
									return $post_ID;
						}
				}
				
				function check_comment($comment_data) {
					global $user_ID, $wpdb, $comment_type;
					
					get_currentuserinfo();

					$input = $_POST['spamq'];					
					// If posting a comment (not trackback etc) and not logged in
					if (  (!isset($user_ID)) && ($comment_data['comment_type']== '')) {
								if ( empty($input) ) {
										// Cache the comment
										setcookie("cached_error_comment", $comment_data['comment_content'], time()+3600);
										// Echo error
										wp_die( __('Error: please answer the anti-spam question.') );
								}
								elseif ( strtolower($input) !== strtolower($this->spam_answer) ) {
										// Cache the comment
										setcookie("cached_error_comment", $comment_data['comment_content'], time()+3600);
										// Echo error
										wp_die( __('Invalid anti-spam answer. Press your browsers back button and try again.') );
								}				
					}
					setcookie("cached_error_comment", "", time()-3600);
					return $comment_data;
				}
		}
}
function WPcommentSpam_head() {		
		?>
        <link href="<?php echo get_bloginfo('wpurl'); ?>/wp-content/plugins/spam-stopper/spam-stopper.css" rel="stylesheet" type="text/css" />
        <?php 
		global $user_ID,$aspamq;
		if (!isset($user_ID)) {	
		if (!is_object($aspamq)) $aspamq = new WPcommentSpam();		
		?>
        <script type="text/javascript" src="<?php echo get_bloginfo('wpurl'); ?>/wp-includes/js/jquery/jquery.js"></script>
		<script type="text/javascript">
			<!--
			jQuery(function(){
					jQuery('#commentform').submit(function(){
							if (jQuery('#author').val()=="") {
								alert("Please input your name");
								return false;     		
							}
							var email_field = jQuery('#email');
							var emailFilter=/^.+@.+\..{2,3}$/;
							if (!emailFilter.test(email_field.val())) {
								alert("Please input a valid email");
								return false;
							}
							if (jQuery('#spamq').val()=="") {
								alert("Please answer the anti-spam question");
								return false;
							}
							if (jQuery('#comment').val()=="") {
								alert("Please input a comment");
								return false;
							}
							var spamq = jQuery('#spamq').val();			
							if (spamq.toUpperCase()!=='<?php echo strtoupper($aspamq->spam_answer); ?>') {
								alert("Incorrect anti-spam answer. Please re-answer the question!");
								return false;
							}
							return true;
					});
			});
			-->
        </script>
		<?php
		}
}
add_action('wp_head', 'WPcommentSpam_head');
if (!is_object($aspamq)) $aspamq = new WPcommentSpam();
?>